using System.Globalization;
using Microsoft.AspNetCore.Localization;
using StockFin;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.
builder.Services.AddControllersWithViews();

builder.Services.Configure<RequestLocalizationOptions>(options =>
{
    var culture = CultureInfo.InvariantCulture;
    options.DefaultRequestCulture = new RequestCulture(culture);
    options.SupportedCultures = [culture];
    options.SupportedUICultures = [culture];
});
builder.Services.AddHttpClient<AlphaVantageService>();
builder.Services.Configure<FinnhubOptions>(
    builder.Configuration.GetSection(FinnhubOptions.SectionName));

builder.Services.AddHttpClient<IFinnhubClient, FinnhubClient>(client =>
{
    client.BaseAddress = new Uri("https://finnhub.io/api/v1/");
});
builder.Services.Configure<TwelveDataOptions>(
    builder.Configuration.GetSection("TwelveData"));
builder.Services
    .AddHttpClient<ITwelveDataClient, TwelveDataClient>(client =>
    {
        client.BaseAddress =
            new Uri("https://api.twelvedata.com/");
    });
    //.AddStandardResilienceHandler();
builder.Services.AddSingleton<StocksCache>();
var app = builder.Build();

// Configure the HTTP request pipeline.
if (!app.Environment.IsDevelopment())
{
    app.UseExceptionHandler("/Home/Error");
    // The default HSTS value is 30 days. You may want to change this for production scenarios, see https://aka.ms/aspnetcore-hsts.
    app.UseHsts();
}

app.UseHttpsRedirection();
app.UseRequestLocalization();
app.UseRouting();

app.UseAuthorization();

app.MapStaticAssets();

app.MapControllerRoute(
    name: "default",
    pattern: "{controller=Home}/{action=Index}/{id?}")
    .WithStaticAssets();


app.Run();
